Package org.apache.commons.collections4.multiset

# Class UnmodifiableSortedMultiSet<E>

java.lang.Object
org.apache.commons.collections4.collection.AbstractCollectionDecorator<E>
org.apache.commons.collections4.multiset.AbstractMultiSetDecorator<E>
org.apache.commons.collections4.multiset.AbstractSortedMultiSetDecorator<E>
org.apache.commons.collections4.multiset.UnmodifiableSortedMultiSet<E>

Type Parameters:
  `E` - The type held in the multiset

All Implemented Interfaces:
  `Serializable`, `Iterable<E>`, `Collection<E>`, `MultiSet<E>`, `SortedMultiSet<E>`, `Unmodifiable`

public final class UnmodifiableSortedMultiSet<E> extends AbstractSortedMultiSetDecorator<E> implements Unmodifiable
Decorates another `SortedMultiSet` to ensure it can't be altered.

Attempts to modify it will result in an UnsupportedOperationException.

Since:
  4.6.0
See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface org.apache.commons.collections4.MultiSet

  `MultiSet.Entry<E>`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `add(E object)`
  Adds one copy of the specified object to the MultiSet.
  `int`
  `add(E object, int count)`
  Adds a number of occurrences of the specified object to the MultiSet.
  `boolean`
  `addAll(Collection<? extends E> coll)`
  `void`
  `clear()`
  `Set<MultiSet.Entry<E>>`
  `entrySet()`
  Returns a `Set` of all entries contained in the MultiSet.
  `Iterator<E>`
  `iterator()`
  Returns an `Iterator` over the entire set of members, including copies due to cardinality.
  `boolean`
  `remove(Object object)`
  Removes one occurrence of the given object from the MultiSet.
  `int`
  `remove(Object object, int count)`
  Removes a number of occurrences of the specified object from the MultiSet.
  `boolean`
  `removeAll(Collection<?> coll)`
  Remove all occurrences of all elements from this MultiSet represented in the given collection.
  `boolean`
  `removeIf(Predicate<? super E> filter)`
  `boolean`
  `retainAll(Collection<?> coll)`
  Remove any elements of this MultiSet that are not contained in the given collection.
  `int`
  `setCount(E object, int count)`
  Sets the number of occurrences of the specified object in the MultiSet to the given count.
  `Set<E>`
  `uniqueSet()`
  Returns a `Set` of unique elements in the MultiSet.
  `static <E> SortedMultiSet<E>`
  `unmodifiableSortedMultiSet(SortedMultiSet<? extends E> multiset)`
  Factory method to create an unmodifiable multiset.

  ### Methods inherited from class org.apache.commons.collections4.multiset.AbstractSortedMultiSetDecorator

  `comparator, decorated, first, last`

  ### Methods inherited from class org.apache.commons.collections4.multiset.AbstractMultiSetDecorator

  `equals, getCount, hashCode`

  ### Methods inherited from class org.apache.commons.collections4.collection.AbstractCollectionDecorator

  `contains, containsAll, isEmpty, setCollection, size, toArray, toArray, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.util.Collection

  `contains, isEmpty, parallelStream, spliterator, stream, toArray, toArray`

  ### Methods inherited from interface java.lang.Iterable

  `forEach`

  ### Methods inherited from interface org.apache.commons.collections4.MultiSet

  `containsAll, equals, getCount, hashCode, size`

- ## Method Details

  - ### unmodifiableSortedMultiSet

    public static <E> SortedMultiSet<E> unmodifiableSortedMultiSet(SortedMultiSet<? extends E> multiset)
    Factory method to create an unmodifiable multiset.

    If the multiset passed in is already unmodifiable, it is returned.

    Type Parameters:
      `E` - the type of the elements in the multiset
    Parameters:
      `multiset` - The multiset to decorate, may not be null
    Returns:
      An unmodifiable SortedMultiSet
    Throws:
      `NullPointerException` - if multiset is null

  - ### add

    public boolean add(E object)
    Description copied from interface: `MultiSet`
    Adds one copy of the specified object to the MultiSet.

    If the object is already in the `MultiSet.uniqueSet()` then increment its count as reported by `MultiSet.getCount(Object)`. Otherwise, add it to the `MultiSet.uniqueSet()` and report its count as 1.

    Specified by:
      `add` in interface `Collection<E>`
    Specified by:
      `add` in interface `MultiSet<E>`
    Overrides:
      `add` in class `AbstractCollectionDecorator<E>`
    Parameters:
      `object` - The object to add.
    Returns:
      `true` always, as the size of the MultiSet is increased in any case.

  - ### add

    public int add(E object, int count)
    Description copied from interface: `MultiSet`
    Adds a number of occurrences of the specified object to the MultiSet.

    If the object is already in the `MultiSet.uniqueSet()` then increment its count as reported by `MultiSet.getCount(Object)`. Otherwise, add it to the `MultiSet.uniqueSet()` and report its count as `occurrences`.

    Specified by:
      `add` in interface `MultiSet<E>`
    Overrides:
      `add` in class `AbstractMultiSetDecorator<E>`
    Parameters:
      `object` - The object to add.
      `count` - The number of occurrences to add, may be zero, in which case no change is made to the multiset.
    Returns:
      The number of occurrences of the object in the multiset before this operation; possibly zero.

  - ### addAll

    public boolean addAll(Collection<? extends E> coll)
    Specified by:
      `addAll` in interface `Collection<E>`
    Overrides:
      `addAll` in class `AbstractCollectionDecorator<E>`

  - ### clear

    public void clear()
    Specified by:
      `clear` in interface `Collection<E>`
    Overrides:
      `clear` in class `AbstractCollectionDecorator<E>`

  - ### entrySet

    public Set<MultiSet.Entry<E>> entrySet()
    Description copied from interface: `MultiSet`
    Returns a `Set` of all entries contained in the MultiSet.

    The returned set is backed by this multiset, so any change to either is immediately reflected in the other.

    Specified by:
      `entrySet` in interface `MultiSet<E>`
    Overrides:
      `entrySet` in class `AbstractMultiSetDecorator<E>`
    Returns:
      The Set of MultiSet entries.

  - ### iterator

    public Iterator<E> iterator()
    Description copied from interface: `MultiSet`
    Returns an `Iterator` over the entire set of members, including copies due to cardinality. This iterator is fail-fast and will not tolerate concurrent modifications.
    Specified by:
      `iterator` in interface `Collection<E>`
    Specified by:
      `iterator` in interface `Iterable<E>`
    Specified by:
      `iterator` in interface `MultiSet<E>`
    Overrides:
      `iterator` in class `AbstractCollectionDecorator<E>`
    Returns:
      iterator over all elements in the MultiSet.

  - ### remove

    public boolean remove(Object object)
    Description copied from interface: `MultiSet`
    Removes one occurrence of the given object from the MultiSet.

    If the number of occurrences after this operation is reduced to zero, the object will be removed from the `MultiSet.uniqueSet()`.

    Specified by:
      `remove` in interface `Collection<E>`
    Specified by:
      `remove` in interface `MultiSet<E>`
    Overrides:
      `remove` in class `AbstractCollectionDecorator<E>`
    Parameters:
      `object` - The object to remove.
    Returns:
      `true` if this call changed the collection.

  - ### remove

    public int remove(Object object, int count)
    Description copied from interface: `MultiSet`
    Removes a number of occurrences of the specified object from the MultiSet.

    If the number of occurrences to remove is greater than the actual number of occurrences in the multiset, the object will be removed from the multiset.

    Specified by:
      `remove` in interface `MultiSet<E>`
    Overrides:
      `remove` in class `AbstractMultiSetDecorator<E>`
    Parameters:
      `object` - The object to remove.
      `count` - The number of occurrences to remove, may be zero, in which case no change is made to the multiset.
    Returns:
      The number of occurrences of the object in the multiset before the operation; possibly zero.

  - ### removeAll

    public boolean removeAll(Collection<?> coll)
    Description copied from interface: `MultiSet`
    Remove all occurrences of all elements from this MultiSet represented in the given collection.
    Specified by:
      `removeAll` in interface `Collection<E>`
    Specified by:
      `removeAll` in interface `MultiSet<E>`
    Overrides:
      `removeAll` in class `AbstractCollectionDecorator<E>`
    Parameters:
      `coll` - The collection of elements to remove.
    Returns:
      `true` if this call changed the multiset.

  - ### removeIf

    public boolean removeIf(Predicate<? super E> filter)
    Specified by:
      `removeIf` in interface `Collection<E>`
    Overrides:
      `removeIf` in class `AbstractCollectionDecorator<E>`

  - ### retainAll

    public boolean retainAll(Collection<?> coll)
    Description copied from interface: `MultiSet`
    Remove any elements of this MultiSet that are not contained in the given collection.
    Specified by:
      `retainAll` in interface `Collection<E>`
    Specified by:
      `retainAll` in interface `MultiSet<E>`
    Overrides:
      `retainAll` in class `AbstractCollectionDecorator<E>`
    Parameters:
      `coll` - The collection of elements to retain.
    Returns:
      `true` if this call changed the multiset.

  - ### setCount

    public int setCount(E object, int count)
    Description copied from interface: `MultiSet`
    Sets the number of occurrences of the specified object in the MultiSet to the given count.

    If the provided count is zero, the object will be removed from the `MultiSet.uniqueSet()`.

    Specified by:
      `setCount` in interface `MultiSet<E>`
    Overrides:
      `setCount` in class `AbstractMultiSetDecorator<E>`
    Parameters:
      `object` - The object to update.
      `count` - The number of occurrences of the object.
    Returns:
      The number of occurrences of the object before this operation, zero if the object was not contained in the multiset.

  - ### uniqueSet

    public Set<E> uniqueSet()
    Description copied from interface: `MultiSet`
    Returns a `Set` of unique elements in the MultiSet.

    Uniqueness constraints are the same as those in `Set`.

    The returned set is backed by this multiset, so any change to either is immediately reflected in the other. Only removal operations are supported, in which case all occurrences of the element are removed from the backing multiset.

    Specified by:
      `uniqueSet` in interface `MultiSet<E>`
    Overrides:
      `uniqueSet` in class `AbstractMultiSetDecorator<E>`
    Returns:
      The Set of unique MultiSet elements.